﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;
using Infragistics.Win;
using Infragistics.Win.UltraWinListView;

namespace UltraTreeDragDropNodes
{
    public partial class Form1 : Form
    {

        private BindingList<MyObject> SourceList;
        private BindingList<MyObject> TargetList;

        public Form1()
        {
            InitializeComponent();

            SourceList = new BindingList<MyObject>();
            TargetList = new BindingList<MyObject>();

            for (int i = 0; i < 10; i++)
            {
                for (int j = 0; j < 10; j++)
                {

                    MyObject mo = new MyObject("Item " + j.ToString());
                    mo.CreateChild();
                    SourceList.Add(mo);
                }
            }

            ultraTree1.DataSource = SourceList;
            MyTargetObject mto = new MyTargetObject("Main Value 1");
            mto.MyTagetList = TargetList;
           // MyTargetList.Add(mto);
            foreach (MyObject obj in TargetList)
            {
                UltraListViewItem item = this.ultraListView1.Items.Add(obj.Item_1);
            }
        }

        private void ultraTree1_SelectionDragStart(object sender, EventArgs e)
        {
            ultraListView1.DoDragDrop((MyObject)ultraTree1.ActiveNode.ListObject, DragDropEffects.Move);
        }

        private void ultraListView1_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }


        private void ultraListView1_DragDrop(object sender, DragEventArgs e)
        {
            UltraListViewItem item = this.ultraListView1.Items.Add(((MyObject)ultraTree1.ActiveNode.ListObject).Item_1);
            item.Value = ((MyObject)ultraTree1.ActiveNode.ListObject).Item_1;
        }


    }

    public class MyObject
    {

        #region Properties
        private string item_1;

        public string Item_1
        {
            get { return item_1; }
            set { item_1 = value; }
        }

        private List<MyObject> childList;

        public List<MyObject> ChildList
        {
            get { return childList; }
            set { childList = value; }
        }
        #endregion

        public MyObject(string It_1)
        {
            this.item_1 = It_1;
        }

        public void CreateChild()
        {
            childList = new List<MyObject>();
            for (int k = 0; k < 10; k++)
            {
                MyObject childObject = new MyObject("Child " + k.ToString() + " at " + this.Item_1);
                childList.Add(childObject);
            }
        }
    }

    public class MyTargetObject
    {
        private string mainItem;

        public string MainItem
        {
            get { return mainItem; }
            set { mainItem = value; }
        }

        private BindingList<MyObject> myTagetList;

        public BindingList<MyObject> MyTagetList
        {
            get { return myTagetList; }
            set { myTagetList = value; }
        }


        public MyTargetObject(string MainIatem)
        {
            this.mainItem = MainIatem;
            this.myTagetList = new BindingList<MyObject>();
        }
    }

}
